// Copyright (c) 2020 FOOSYS. All rights reserved.
// ƗCu

#pragma once

#include "LibType.hpp"
#include "Bitmap.hpp"

namespace nfl
{

/*****************************************************************************************/
// ev[g
/*****************************************************************************************/

/// <summary>
/// Win32 API DwmGetWindowAttributẽwp[֐ev[g
/// </summary>
/// <typeparam  name="T">DwmGetWindowAttributeŎ擾̌^</param>
/// <param name="hWnd">EBhEnh</param>
/// <param name="attribute">DwmGetWindowAttributeɓn</param>
/// <returns>DwmGetWindowAttributeŎ擾</returns>
template <class T>
T dwmGetWindowAttribute(HWND hWnd, DWORD attribute)
{
	T result = { 0 };
	::DwmGetWindowAttribute(hWnd, attribute, &result, sizeof(T));
	return result;
}

/// <summary>
/// w菑擾
/// </summary>
/// <typeparam  name="N"></param>
/// <returns>w菑</returns>
template<INT N>
std::wstring getDigitFormat()
{
	const UINT bufferSize = 5 + N / 10;
	WCHAR buffer[bufferSize] = { L'\0' };
	wsprintf(buffer, L"%s0%dd", L"%", N);
	return std::wstring(buffer);
}

/// <summary>
/// fnŎw肵K֐o͂̋`W擾
/// </summary>
/// <typeparam name="fn">`o͂֐̌^</param>
/// <param name="hWnd">EBhEnh</param>
/// <returns>`W</returns>
template<class Fn>
RECT getObjectRect_f(HWND hWnd, Fn fn)
{
	RECT rect = { 0 };
	fn(hWnd, &rect);
	return rect;
}

/// <summary>
/// UINTl16iɕϊ
/// </summary>
/// <typeparam  name="N">o͂16ǐ</param>
/// <param name="value">16iɕϊl</param>
/// <returns>16i</returns>
template <UINT N>
std::wstring toHexWString(UINT value)
{
	WCHAR buf[N + 3] = { L'\0' };
	std::wstringstream ws;
	ws << L"0x%0" << N << L"X";
	wsprintf(buf, ws.str().c_str(), value);
	return buf;
}

/// <summary>
/// wll𕶎ɕϊ
/// </summary>
/// <typeparam  name="N">ɕϊľ^</param>
/// <param name="val">ɕϊl</param>
/// <returns>͒l̕</returns>
template<class T>
std::wstring toString(T val)
{
	std::wstringstream ws;
	ws << val;
	return ws.str();
}

/*****************************************************************************************/
// NX
/*****************************************************************************************/

/// <summary>
/// ̃NX̃CX^X݂ĂԁAL[у}EX͂ubN
/// </summary>
/// <remarks>
/// ̃NX̎gpɂĂ͊ǗғKv
/// \vpeBJ}jtFXgt@CUAC̎sxrequireAdministrator
/// </remarks>
class BlockInput
{
public:
	BlockInput()
	{
		::BlockInput(TRUE);
	}

	~BlockInput()
	{
		::BlockInput(FALSE);
	}
};

/// <summary>
/// CloseHandlept@N^
/// </summary>
struct CloseHandleDeleter
{
	VOID operator()(HANDLE handle) const
	{
		if (handle && handle != INVALID_HANDLE_VALUE)
		{
			::CloseHandle(handle);
		}
	}
};

/// <summary>
/// DeleteObjectpt@N^[
/// </summary>
template <class T>
struct Deleter
{
	void operator()(T handle) const
	{
		if (handle)
			::DeleteObject(handle);
	}
};

/// <summary>
/// ꎞIwEBhE\ɂRAIINX
/// </summary>
class HideTemporarily final
{
public:
	explicit HideTemporarily(HWND hWnd)
	{
		hWnd_ = hWnd;
		::ShowWindow(hWnd, SW_HIDE);
	}
	HideTemporarily() = delete;
	VOID restore()
	{
		::ShowWindow(hWnd_, SW_SHOW);
	}

private:
	static HWND hWnd_;
};

/// <summary>
/// BeginPaint, EndPaintpRAIINX
/// </summary>
struct PaintObject
{
	explicit PaintObject(HWND hWnd) : hWnd_(hWnd), hDC_(::BeginPaint(hWnd, &ps_)) { }
	PaintObject() = delete;
	~PaintObject() { ::EndPaint(hWnd_, &ps_); }
	HDC getDC() const { return hDC_; }
private:
	HWND hWnd_;
	HDC hDC_;
	PAINTSTRUCT ps_;
};

/// <summary>
/// EBhDʒu𐧌䂷NX
/// </summary>
class Position
{
public:
	Position()
		: hWnd_{ nullptr }, current_{ 0 }, previous_{ 0 }
	{
	}

	VOID initialize(HWND hWnd, LONG x, LONG y)
	{
		hWnd_ = hWnd;
		current_.x = x;
		current_.y = y;
	}

	VOID move(POINT point)
	{
		::ClientToScreen(hWnd_, &point);
		current_.x += point.x - previous_.x;
		current_.y += point.y - previous_.y;
		previous_ = point;
	}

	VOID clicked(POINT point)
	{
		::ClientToScreen(hWnd_, &point);
		previous_ = point;
	}

	LONG getX() const { return current_.x; }
	LONG getY() const { return current_.y; }

private:
	HWND hWnd_;
	POINT current_, previous_;
};

/// <summary>
/// ReleaseDCpt@N^
/// </summary>
struct ReleaseDcDeleter
{
	explicit ReleaseDcDeleter(HWND hWnd) : hWnd_(hWnd) {}
	VOID operator()(HDC hDC) const
	{
		if (hDC)
		{
			if (hWnd_ && hDC)
				::ReleaseDC(hWnd_, hDC);
		}
	}
	HWND hWnd_;
};

/// <summary>
/// SelectObjectpRAIINX
/// </summary>
template <class T>
struct Selector
{
	Selector(HDC hDC, HGDIOBJ hGdiObj) : hDC_(hDC), hOld_(::SelectObject(hDC, hGdiObj)) { }
	Selector() = delete;
	~Selector()
	{
		if (hDC_ && hOld_)
			::SelectObject(hDC_, static_cast<T>(hOld_));
	}
private:
	HDC hDC_;
	HGDIOBJ hOld_;
};

/*****************************************************************************************/
// ֐
/*****************************************************************************************/

/*
	W֘A
*/

/// <summary>
/// ͍WfXNgbvȌꍇA^񒆕t߂ɍW
/// </summary>
/// <param name="x">XW</param>
/// <param name="y">YW</param>
/// <returns>ꂽW</returns>
POINT adjustPointWithInDesktop(INT x, INT y);

/// <summary>
/// RECT}`j^lRECTɕϊ
/// </summary>
/// <param name="rect">RECTT</param>
/// <returns>}`j^lRECT</returns>
RECT&& applyMultiMonitor(RECT&& rect);

/// <summary>
/// RECTSIZE
/// </summary>
/// <param name="rect">RECT\</param>
/// <returns>SIZE\</returns>
SIZE changeRectToSize(const RECT& rect);

/// <summary>
/// RECTSIZEASIZE+N
/// </summary>
/// <param name="rect">RECT\</param>
/// <returns>SIZE\</returns>
SIZE changeRectToSizePlusN(const RECT& rect, LONG plusN);

/// <summary>
/// NbsO(targetValueclippingValue菬targetValueclippingValueɂ)
/// </summary>
/// <param name="targetValue">NbsOΏےl</param>
/// <param name="clippingValue">NbsO臒l</param>
/// <returns>NbsOꂽl</returns>
LONG clipLess(LONG targetValue, LONG clippingValue);

/// <summary>
/// NbsO(targetValueclippingValue傫targetValueclippingValueɂ)
/// </summary>
/// <param name="targetValue">NbsOΏےl</param>
/// <param name="clippingValue">NbsO臒l</param>
/// <returns>NbsOꂽl</returns>
LONG clipGreater(LONG targetValue, LONG clippingValue);


/// <summary>
/// }EXJ[\ʒuNCAgWŎ擾
/// </summary>
/// <param name="hWnd">EBhEnh</param>
POINT getCursorClientPosition(HWND hWnd);

/// <summary>
/// NCAgWXN[W擾
/// </summary>
/// <param name="hWnd">NCAgGAgEBhEnh</param>
/// <param name="clientCoordinate">NCAgW</param>
/// <returns>XN[W</returns>
POINT getScreenCoordinate(HWND hWnd, const POINT& clientCoordinate);

/// <summary>
/// NCAgWPOINTi[ĂLPARAMXN[WPOINT
/// </summary>
/// <param name="hWnd">ΏۃNCAgEBhẼEBhEnh</param>
/// <param name="lParam">NCAgWPOINTi[ĂLPARAM</param>
/// <returns>XN[WPOINT</returns>
POINT getScreenCoordinateFromLParam(HWND hWnd, LPARAM lParam);

/// <summary>
/// eȂEBhE`W擾
/// </summary>
/// <param name="hWnd">EBhEnh</param>
/// <returns>eȂEBhE`W</returns>
RECT getWindowRectNoShadow(HWND hWnd);

/// <summary>
/// }`j^ĂfXNgbv`擾
/// </summary>
/// <returns>}`j^ĂfXNgbv`</returns>
RECT getVirtualDesktopRect();

/*
	EBhE֘A
*/

/// <summary>
/// EBhE쐬
/// </summary>
/// <param name="dwExStyle">EBhE̊gX^C</param>
/// <param name="dwStyle">EBhEX^C</param>
/// <param name="lpClassName">EBhENX</param>
/// <param name="hWndParent">eEBhE܂̓I[i[EBhẼnh</param>
/// <param name="hInstance">AvP[VCX^X̃nh</param>
/// <param name="lpWindowName">EBhE</param>
/// <param name="position">EBhẺAc̈ʒu</param>
/// <param name="size">EBhE̕A</param>
/// <returns>EBhEnh</returns>
HWND createMyWindow(DWORD dwExStyle, DWORD dwStyle, LPCWSTR lpClassName, HWND hWndParent = nullptr, HINSTANCE hInstance = nullptr, LPCWSTR lpWindowName = nullptr, POINT position = { 0, 0 }, SIZE size = { 1, 1 });

/// <summary>
/// BEBhEǂf
/// </summary>
/// <param name="hWnd">EBhEnh</param>
/// <returns>trueFBEBhEłAfalseFBEBhEłȂ</returns>
bool isCloakeWindow(HWND hWnd);

/// <summary>
/// EBhEnhhWnd2̃EBhEAEBhEnhhWnd1̃EBhEɊ܂܂邩ǂf
/// </summary>
/// <param name="hWnd1">EBhEnh</param>
/// <param name="hWnd1">EBhEnh</param>
bool isIncluding(HWND h1, HWND h2);

/// <summary>
/// EBhEnhhWnd2̃EBhEAEBhEnhhWnd1̃EBhEƏdȂĂ邩ǂf
/// </summary>
/// <param name="hWnd1">EBhEnh</param>
/// <param name="hWnd1">EBhEnh</param>
/// <returns>trueFdȂĂAfalseFdȂĂȂ</returns>
bool isOverlapping(HWND h1, HWND h2);

/// <summary>
/// EBhENXo^
/// </summary>
/// <param name="hInstance">EBhEvV[WێĂEBhẼCX^Xnh</param>
/// <param name="wndProc">EBhEvV[W</param>
/// <param name="hbrBackground">wiF\uVnh</param>
/// <param name="lpszClassName">EBhENX</param>
/// <param name="hIcon">ACR̃nh</param>
/// <param name="hIconSm">16~16̏TCỸACR̃nh</param>
/// <param name="hCursor">}EXJ[\̃nh</param>
/// <returns>EBhEӂɎʂAg</returns>
ATOM registerWindowClass(HINSTANCE hInstance, WNDPROC wndProc, HBRUSH hbrBackground, LPCWSTR lpszClassName, HICON hIcon = nullptr, HICON hIconSm = nullptr, HCURSOR hCursor = nullptr);

/*
	Rg[֘A
*/

/// <summary>
/// R{{bNX̑IĂACẽCfbNX擾
/// </summary>
/// <param name="hComboBox">R{{bNX̃EBhEnh</param>
/// <returns>CfbNX</returns>
INT comboBoxGetSelectedIndex(HWND hComboBox);

/// <summary>
/// `FbN{bNXɃ`FbNĂ邩ǂf
/// </summary>
/// <param name="hCheckBox">`FbN{bNX̃EBhEnh</param>
/// <returns>trueF`FbNĂAfalseF`FbN͓ĂȂ</returns>
bool checkBoxIsChecked(HWND hCheckBox);

/// <summary>
/// `FbN{bNX̃`FbN𑀍삷
/// </summary>
/// <param name="hCheckBox">`FbN{bNX̃EBhEnh</param>
/// <param name="check">trueF`FbNAfalseF`FbNO</param>
VOID checkBoxSetCheck(HWND hCheckBox, bool check);

/// <summary>
/// R{{bNX̃ACeCfbNXɂđI
/// </summary>
/// <param name="hComboBox">R{{bNX̃EBhEnh</param>
/// <param name="index">CfbNX</param>
/// <param name="defalutVaule">CfbNX݂ȂꍇAICfbNX</param>
VOID comboBoxSelectIndex(HWND hComboBox, INT index, INT defalutVaule);

/// <summary>
/// R{{bNXɕ}
/// </summary>
/// <param name="hComboBox">R{{bNX̃EBhEnh</param>
/// <param name="text">}镶</param>
VOID comboBoxInsertString(HWND hComboBox, LPCWSTR text);

/// <summary>
/// R{{bNX̃ACe𕶎ɂđI
/// </summary>
/// <param name="hComboBox">R{{bNX̃EBhEnh</param>
/// <param name="text">I镶</param>
VOID comboBoxSelectItem(HWND hComboBox, LPCWSTR text);


/// <summary>
/// c[r[ɂĎwHTREEITEM̕擾
/// </summary>
/// <param name="hTree">c[r[̃EBhEnh</param>
/// <param name="hItem">wHTREEITEM</param>
/// <returns>wHTREEITEM̕</returns>
std::wstring treeViewGetSlectedItemString(HWND hTree, HTREEITEM hItem);

/// <summary>
/// c[r[ɂĎw蕶̃ACeI
/// </summary>
/// <param name="hTree">c[r[̃EBhEnh</param>
/// <param name="hItem">wACeHTREEITEM</param>
/// <param name="treeViewSelectedItemString">w蕶</param>
/// <returns>trueFIAfalseFIȂ</returns>
VOID treeViewSelecteItem(HWND hTree, const std::wstring& treeViewSelectedItemString, INT limiter = 10);

/// <summary>
/// EBhE܂̓Rg[當擾
/// </summary>
/// <param name="hTarget">^[QbgIuWFNg</param>
/// <returns>^[Qbg̕</returns>
std::wstring getWindowText(HWND hTarget);

/// <summary>
/// Rg[̕擾
/// </summary>
/// <param name="hDlg">̃Rg[悹Ă_CAÕEBhEnh</param>
/// <param name="nIDDlgItem">Rg[ʎq</param>
/// <returns>Rg[̕</returns>
std::wstring getWindowText(HWND hDlg, int nIDTarget);

/// <summary>
/// Rg[ɕݒ肷
/// </summary>
/// <param name="hDlg">̃Rg[悹Ă_CAÕEBhEnh</param>
/// <param name="nIDDlgItem">Rg[ʎq</param>
/// <param name="text">ݒ肷镶</param>
VOID setWindowText(HWND hDlg, int nIDDlgItem, LPCWSTR text);

/*
	foCXReLXg֘A
*/

/// <summary>
/// BitBlt
/// </summary>
/// <param name="dstHDC">^[QbgfoCXReLXg̃nh</param>
/// <param name="dstSize">^[QbgTCY</param>
/// <param name="srcHDC">\[XfoCXReLXg̃nh</param>
/// <param name="srcPoint">\[Xʒu</param>
VOID bitBlt(HDC dstHDC, SIZE dstSize, HDC srcHDC, POINT srcPoint = { 0 });

/// <summary>
/// BitBlt
/// </summary>
/// <param name="dstHDC">^[QbgfoCXReLXg̃nh</param>
/// <param name="dstRect">^[Qbg`</param>
/// <param name="srcHDC">\[XfoCXReLXg̃nh</param>
/// <param name="srcPoint">\[Xʒu</param>
VOID bitBlt(HDC dstHDC, RECT dstRect, HDC srcHDC, POINT srcPoint);

/// <summary>
/// Rp`foCXReLXg
/// </summary>
/// <param name="hBitmap">Rp`foCXReLXgɊ蓖ĂHBITMAP</param>
/// <returns>foCXReLXgnhbvunique_ptr</returns>
PHDCD_t createCompatibleDC(HBITMAP hBitmap);

/*
	t@CEpX֘A
*/

/// <summary>
/// pXɃobNXbVt
/// </summary>
/// <param name="path">pX</param>
VOID addBackSlash(std::wstring& path);

/// <summary>
/// wpXz̑StH_ESt@C폜
/// </summary>
/// <param name="basePath">wpX</param>
VOID deleteFiles(std::wstring basePath, std::wstring exclusionFile = L"");

/// <summary>
/// st@CtpXŎ擾܂
/// </summary>
/// <returns>tpXtst@C</returns>
std::wstring getExeFilePathName();

/// <summary>
/// st@C擾܂
/// </summary>
/// <returns>tpXtst@C</returns>
std::wstring getExeFileName();

/// <summary>
/// tpXt@C擾܂
/// </summary>
/// <param name="fullPath">tpXtt@C</param>
/// <returns>t@C</returns>
std::string getFileNameFromFullPathA(const CHAR* fullPath);

/// <summary>
/// e|tH_̃pX擾
/// </summary>
/// <returns>e|tH_̃pX</returns>
std::wstring getTmpFolder();

/// <summary>
/// SHBrowseForFolderŃt@CI
/// </summary>
/// <param name="hOwner">I[i[̃EBhEnh</param>
/// <param name="defaultFolder">ftHgtH_</param>
/// <param name="caption">LvV</param>
/// <param name="description">c[r[㕔̕\</param>
std::wstring selectFile(HWND hOwner, std::wstring defaultFolder, std::wstring caption = L"", std::wstring description = L"");

/// <summary>
/// SHBrowseForFolderŃtH_I
/// </summary>
/// <param name="hOwner">I[i[̃EBhEnh</param>
/// <param name="defaultFolder">ftHgtH_</param>
/// <param name="caption">LvV</param>
/// <param name="description">c[r[㕔̕\</param>
/// <returns>ItH_̃tpX</returns>
std::wstring selectFolder(HWND hOwner, std::wstring defaultFolder, std::wstring caption = L"", std::wstring description = L"");

/// <summary>
/// wtH_ɑ݂t@Cꗗo͂
/// </summary>
/// <param name="searchPath">wtH_</param>
/// <param name="output">o͂t@Cꗗ</param>
VOID storeFileName(const std::wstring& searchPath, std::vector<std::wstring>& output);

/// t@CWrite
/// </summary>
/// <param name="hFile">t@C̃nh</param>
/// <param name="lpBuffer">ރf[^</param>
/// <param name="nNumberOfBytesToWrite">ރf[^̃TCY</param>
/// <returns>trueFݐAfalseFݎs</returns>
bool writeFile(HANDLE hFile, LPCVOID lpBuffer, DWORD nNumberOfBytesToWrite);

/*
	t֘A
*/

/// <summary>
/// ̓t擾
/// </summary>
/// <returns>N</returns>
std::wstring getDate();

/*
	
*/

/// <summary>
/// 蓮CxgIuWFNg
/// </summary>
/// <param name="eventObjectName">CxgIuWFNɖt閼O</param>
/// <param name="initialSignalState"> TRUEFVOiԁAFALSAEFmVOi</param>
/// <returns>CxgIuWFNgnhbvunique_ptr</returns>
UPHANDLE_t createManualResetEvent(const std::wstring& eventObjectName, BOOL initialSignalState);

/// <summary>
/// w蕶̕ƍ擾
/// </summary>
/// <param name="hDC">foCXReLXg̃nh</param>
/// <param name="string">ƍ擾</param>
/// <returns>̕ƍi[SIZE\</returns>
SIZE getStringSize(HDC hDC, const std::wstring& string);

/// <summary>
/// exe/dllCopyright擾
/// </summary>
/// <returns>Copyright</returns>
std::wstring getCopyrightFromResource();

/// <summary>
/// exe/dllo[W擾
/// </summary>
/// <returns>o[W</returns>
std::wstring getVersionFromResource();

/// <summary>
/// OAvN
/// </summary>
/// <param name="hWnd">eEBhẼEBhEnh</param>
/// <param name="file">OAv</param>
/// <param name="param">OAvɓnp[^Bp[^ꍇ͋󔒋؂ɂ</param>
/// <returns>trueFNAfalseFNs</returns>
bool launchExternalApp(HWND hWnd, LPCWSTR file, LPCWSTR param);

} // namespace nfl

