// Copyright (c) 2020 FOOSYS. All rights reserved.
#pragma once
#include "stdafx.h"
#include "ResourceManager.hpp"
#include "LibFunc.hpp"

namespace FOOSYS
{

ResourceManager::ResourceManager()
: string_(), appName_(), hInstance_(nullptr), languageKind_(Japanese)
{
	createString();
};

VOID ResourceManager::createString()
{
	const std::wstring version = nfl::getVersionFromResource();
	const std::wstring copyright = nfl::getCopyrightFromResource();
	const std::wstring homePage = L"http://www.eonet.ne.jp/~foosys/app/lc/index.html";

	// R}h{^c[`bv
	string_[CommandButtonCutRectangle] = { L"`̐؂", L"Cut out a rectangle" };
	string_[CommandButtonCutWindow] = { L"EBhE̐؂", L"Cut out a window" };
	string_[CommandButtonCutHiddenWindow] = { L"BEBhE̐؂", L"Cut out a partially hidden window" };
	string_[CommandButtonDesktop] = { L"fXNgbv̐؂", L"Cut out the desktop" };
	string_[CommandButtonSettings] = { L"ݒ", L"Settings" };

	// IvV{^c[`bv
	string_[OptionButtonCutRectangle] = { L"Y[EBhE OFF^ON", L"Zoom window OFF^ON" };
	string_[OptionButtonCutWindow] = { L"gbvEBhE^SEBhE", L"Top window^All windows" };
	string_[OptionButtonCutHiddenWindow] = { L"gbvEBhE^SEBhE", L"Top window^All windows" };
	string_[OptionButtonDesktop] = { L"x؂ OFF^ON", L"Delayed cut out OFF^ON" };
	string_[OptionButtonSettings] = { L"Japanese^English", L"Japanese^English" };

	// ^Cgo[{^c[`bv
	string_[CloseButton] = { L"", L"Close" };
	string_[MinimizeButton] = { L"ŏ", L"Minimize" };
	string_[MouseCursorCaptureOnOff] = { L"}EXJ[\Lbv` OFF^ON", L"Capture mouse cursor OFF^ON" };

	// }EXc[`bv
	string_[WindowHandle] = { L"nh", L"Handle" };
	string_[WindowWidth] = { L"", L"Width" };
	string_[WindowHeight] = { L"", L"Width" };

	// G[bZ[W
	string_[CaptureFailed] = { L"G[", L"Error" };
	string_[BitmapCreationFailed] = { L"rbg}bvs", L"Bitmap creation failed" };
	string_[CreateWindowFailed] = { L"EBhEs", L"Window creation failed" };
	string_[IniFileSaveFailed] = { L"init@Cւ̐ݒl̕ۑɎs܂", L"Failed to save setting value to ini. file" };
	string_[NoViewer] = { L"؂摜{Avw肵ĉ", L"Specify a cropped image viewing application" };
	string_[NoSaveFolder] = { L"؂摜̈ꎞۑtH_w肵ĉ", L"Specify the temporary saving folder for cropped images" };
	string_[ViewerStartUpFailed] = { L"摜{Av̋NɎs܂", L"Failed to start the viewer" };
	string_[IniFileInitializationFailed] = { L"init@C̏Ɏs܂", L"ini. file initialization failed" };
	string_[BrowserStartupFailed] = { L"uEŰNɎs܂", L"Failed to start browser" };
	string_[InvalidFolderForTemporarySavingImages] = { L"؂摜̈ꎞۑtH_݂܂B\r\nݒʂŐpXݒ肵ĉB", L"Folder for temporary saving images does not exist.\r\nSet the correct path in the settings dialog." };

	// bZ[W
	string_[SettingInitialization] = { L"ݒlɖ߂܂B낵łH", L"Do you want to reset the settings to the default values?" };

	// ݒ_CAO
	string_[SettingsDlgTitleBar] = { L"ݒ", L"Settings" };
	string_[SettingsDlgTreeCaption] = { L"ݒꗗ(&S)", L"List of settings(&S)" };
	string_[SettingsDlgBtnInitialize] = { L"lɖ߂(&I)", L"Initialization(&I)" };
	string_[SettingsDlgBtnCancel] = { L"LZ(&C)", L"Cancel(&C)" };
	string_[SettingsDlgTreeItemGeneral] = { L"S", L"General" }; 
	string_[SettingsDlgTreeItemApp] = { L"Avݒ", L"App. settings" };
	string_[SettingsDlgTreeItemCapture] = { L"؂", L"Capture" };
	string_[SettingsDlgTreeItemRectangleCapture] = { L"`", L"Rectanglel" };
	string_[SettingsDlgTreeItemWindowCapture] = { L"EBhE", L"Window" };
	string_[SettingsDlgTreeItemHiddenWindowCapture] = { L"BEBhE", L"Hidden window" };
	string_[SettingsDlgTreeItemDesktopCapture] = { L"fXNgbv", L"Desktop" };

	string_[SettingsDlgVersion] = { L" o[W " + version, L" Version " + version };
	string_[SettingsDlgCopyright] = { copyright, copyright };
	string_[SettingsDlgHomePage] = { homePage, homePage };
	string_[SettingsDlgTopMost] = { L"AvɑOʂɕ\(&F)", L"Keep app in front(&F)" };
	string_[SettingsDlgButtonToolTip] = { L"{^c[`bv\(&T)", L"Show button tooltip(&T)" };

	string_[SettingsDlgViewerApp] = { L"؂摜{Av(&A)", L"Image browsing app(&A)" };
	string_[SettingsDlgSaveImage] = { L"؂摜̈ꎞۑtH_(&F)", L"Folder for temporary saving images(&F)" };
	string_[SettingsDlgDelImage] = { L"IɈꎞۑ摜t@C폜(&D)", L"Delete temporarily saved image files when finished(&D)" };
	string_[SettingsDlgClipBoard] = { L"Nbv{[h(&L)", L"Clipboard(&L)" };
	string_[SettingsDlgClipBoardNone] = { L"Nbv{[hɃRs[Ȃ", L"Do not copy to clipboard" };
	string_[SettingsDlgClipBoardOnly] = { L"Nbv{[hɂ̂݃Rs[ ( {AvNȂ )", L"Copy only to clipboard (Do not launch browsing app)" };
	string_[SettingsDlgClipBoardImage] = { L"Nbv{[hɃRs[", L"Copy image to clipboard" };
	string_[SettingsDlgClipBoardText] = { L"}EXc[`bvNbv{[hɃRs[", L"Copy mouse tooltip to clipboard" };
	string_[SettingsDlgAuxiliaryLineColor] = { L"⏕̐F(&U)", L"Auxiliary line color(&U)" };
	string_[SettingsDlgAuxiliaryLine] = { L"}EXhbO\⏕\(&U)", L"Show auxiliary line while dragging(&U)" };
	string_[SettingsDlgZoomMagnification] = { L"Y[EBhE̔{(&M)", L"Zoom window magnification(&M)" };
	string_[SettingsDlgMouseToolTip] = { L"}EXc[`bv\(&T)", L"Show mouse tooltip(&T)" };
	string_[SettingsDlgDelaySettings] = { L"xݒ", L"Delay settings" };
	string_[SettingsDlgDelay] = { L"x؂肷", L"Delayed cut" };
	string_[SettingsDlgDelaySeconds] = { L"xb(&D)", L"Delay seconds(&D)" };

	string_[ColorPaletteCaptionBlack] = { L"", L"Black" };
	string_[ColorPaletteCaptionSorrel] = { L"IF", L"Sorrel" };
	string_[ColorPaletteCaptionGreen] = { L"", L"Green" };
	string_[ColorPaletteCaptionOlive] = { L"I[u", L"Olive" };
	string_[ColorPaletteCaptionNavyBlue] = { L"", L"Navy blue" };
	string_[ColorPaletteCaptionPurple] = { L"", L"Purple" };
	string_[ColorPaletteCaptionBlueGreen] = { L"", L"Blue green" };
	string_[ColorPaletteCaptionGray] = { L"O[", L"Gray" };
	string_[ColorPaletteCaptionSilver] = { L"F", L"Silver" };
	string_[ColorPaletteCaptionRed] = { L"", L"Red" };
	string_[ColorPaletteCaptionYellowishGreen] = { L"", L"Yellowish green" };
	string_[ColorPaletteCaptionYellow] = { L"", L"Yellow" };
	string_[ColorPaletteCaptionBlue] = { L"", L"Blue" };
	string_[ColorPaletteCaptionRedPurple] = { L"Ԏ", L"Red-purple" };
	string_[ColorPaletteCaptionLightBlue] = { L"F", L"Light blue" };
	string_[ColorPaletteCaptionWhite] = { L"", L"White" };


	string_[SelectFolderCaption] = { L"tH_̎Q", L"Browse folder" };
	string_[SelectFolderDescription] = { L"؂摜ۑtH_IĂ", L"Select a folder to save the cropped image" };
	string_[SelectFileCaption] = { L"t@C̎Q", L"Browse file" };
	string_[SelectFileDescription] = { L"؂摜{AvIĂ", L"Select an app to view cropped images" };

	string_[LabelSecond] = { L"b", L"Sec." };
}

ResourceManager& ResourceManager::get()
{
	static ResourceManager resourceManager;
	return resourceManager;
}

std::wstring ResourceManager::getString(ID stringEnum) const
{
	return string_[stringEnum][languageKind_];
}

LPCWSTR ResourceManager::getStringPointer(ID stringEnum) const
{
	return string_[stringEnum][languageKind_].c_str();
}

std::string ResourceManager::getStringA(ID stringEnum) const
{
	USES_CONVERSION;
	return W2A(string_[stringEnum][languageKind_].c_str());
}

std::wstring ResourceManager::getAppName() const
{
	return appName_;
}

std::string ResourceManager::getAppNameA() const
{
	USES_CONVERSION;
	return W2A(appName_.c_str());
}

std::wstring ResourceManager::getSaveFolderName() const
{
	return L"__LETS_CAPTURE__";
}


} // namespace FOOSYS
